/*
 * @file
 * Javascript for showing and hiding dependent attributes.
 *
 * Retrieves the dependencies from the database using a callback and shows
 * and hides attributes depending upon the value selected for the attribute
 * they depend upon.
 */

Drupal.behaviors.uc_dropdown_attributes = function(context) {
  // Retrieve the node id
  var nid = $('div.add-to-cart').find(':input[name="node_id"]').val();
  $('div.attributes').find('div').each( function(i,val) {
    var attributes = $(val).attr('class').split(' ');
    if (attributes[1] != undefined) {
      var aid = attributes[1].split('-')[1];
      $.get('/node/' + nid + '/view/dependencies/' + aid + '/callback', null,
            readAttribute);
    }
  });
}

var readAttribute = function(response) {
  var result = Drupal.parseJson(response);
  if (result.status) {
    $('#edit-attributes-' + result.parent_aid).change(function() {
      value=$('#edit-attributes-' + result.parent_aid).val();
      if (value != undefined) {
        if (result.parent_values[value] == undefined) {
          $('#edit-attributes-' + result.aid + '-wrapper').slideUp();
        } 
        else {
          if (result.parent_values[value] != undefined) {
            $('#edit-attributes-' + result.aid + '-wrapper').slideDown();
          }
          else {
            $('#edit-attributes-' + result.aid + '-wrapper').slideUp();
          }
        }
      }
    });
    $('#edit-attributes-' + result.parent_aid + '-1').change(function() {
      value=$('#edit-attributes-' + result.parent_aid + '-1').val();
      if (value != undefined) {
        if (result.parent_values[value] == undefined) {
          $('#edit-attributes-' + result.aid + '-1-wrapper').slideUp();
        } else {
          if (result.parent_values[value] != undefined) {
            $('#edit-attributes-' + result.aid + '-1-wrapper').slideDown();
          }
          else {
            $('#edit-attributes-' + result.aid + '-1-wrapper').slideUp();
          }
        }
      }
    });
    if (result.required == 1) {
      $('#edit-attributes-' + result.aid + '-wrapper').find('label').replaceWith('<label>' +$('#edit-attributes-' + result.aid + '-wrapper').find('label').text() + '<span class="form-required" title="' + Drupal.t('This field is required.') + '">*</span></label>');
      $('#edit-attributes-' + result.aid + '-1-wrapper').find('label').replaceWith('<label>' +$('#edit-attributes-' + result.aid + '-1-wrapper').find('label').text() + '<span class="form-required" title="' + Drupal.t('This field is required.') + '">*</span></label>');
    }
    value = $('#edit-attributes-' + result.parent_aid).val();
    if (value != undefined) {
      if (result.parent_values[value] == undefined) {
        $('#edit-attributes-' + result.aid + '-wrapper').slideUp();
      } else {
        if (result.parent_values[value] != undefined) {
          $('#edit-attributes-' + result.aid + '-wrapper').slideDown();
        }
        else {
          $('#edit-attributes-' + result.aid + '-wrapper').slideUp();
        }
      }
    }
    value = $('#edit-attributes-' + result.parent_aid + '-1').val();
    if (value != undefined) {
      if (result.parent_values[value] == undefined) {
        $('#edit-attributes-' + result.aid + '-1-wrapper').slideUp();
      } else {
        if (result.parent_values[value] != undefined) {
          $('#edit-attributes-' + result.aid + '-1-wrapper').slideDown();
        }
        else {
          $('#edit-attributes-' + result.aid + '-1-wrapper').slideUp();
        }
      }
    }
  }
}

